clear all; close all;

% load images
count = 5;
im_names = cell(count, 1);
for k = 1:count
    im_names{k} = strcat('data/hanoi_mask_', num2str(k), '.png');
end

% read images into stack, compute max gradient
[m, n, c] = size(imread(im_names{1}));
stack = zeros([m, n, c, count]);
gradients = zeros([m, n, count]);
for k=1:count 
    im = rgb2gray(im2double(imread(im_names{k})));
    im(im == 0) = NaN;
    stack(:,:,k) = im;    
    
    [g_mag, g_dir] = imgradient(im(:,:));
    gradients(:,:,k) = g_mag;
end

[M, I] = max(gradients,[],3);

% generate all-in-focus image
focus = zeros([m, n]);
for x = 1:size(I,1)
   for y = 1:size(I,2)
       focus(x, y) = stack(x, y, I(x,y));  
   end
end
imshow(focus);

% use all-in-focus image to calculate depth
depth = zeros([m, n, c]);

I = (I-min(I(:))) ./ (max(I(:))-min(I(:)));
depth(:,:,1) = I;
depth(:,:,2) = ones([m,n]);
M(isnan(focus)) = NaN;
depth(:,:,3) = M;

% not very consistent or accurate, unfortunately
figure;
imshow(hsv2rgb(depth)); 
imwrite(hsv2rgb(depth), 'output/depth.png');
